#include "interfEditMenu.h"


interfEditMenu::interfEditMenu(wxWindow * parent, int sizex, int sizey,wxEvtHandler* evtHandler, std::string datdir)
	: interfMenuBar(parent, sizex, sizey)
{
	this->datadir = datdir;
//	eventHandler = evtHandler;
	initButtons(this);
}

void interfEditMenu::initButtons(wxEvtHandler* evtHandler) {

	std::vector<std::string> path, nom;
	std::vector<wxObjectEventFunction> funct;

	path.push_back(datadir + "/copy.png");
	nom.push_back("Copy the selected contour  ctrl + c");
	funct.push_back((wxObjectEventFunction) &interfEditMenu:: onCopy);

	path.push_back(datadir + "/paste.png");
	nom.push_back("Paste the copied contour  ctrl + v");
	funct.push_back((wxObjectEventFunction) &interfEditMenu:: onPaste);

	path.push_back(datadir + "/undo.png");
	nom.push_back("Undo  ctrl + z");
	funct.push_back((wxObjectEventFunction) &interfEditMenu:: onUndo);

	path.push_back(datadir + "/redo.png");
	nom.push_back("Redo  ctrl + y");
	funct.push_back((wxObjectEventFunction) &interfEditMenu:: onRedo);

//CMRU 17-08-09 ------------------------------------------------------------------
	path.push_back(datadir + "/Letter.PNG");
	nom.push_back("Insert a Label");
	funct.push_back((wxObjectEventFunction)&interfEditMenu::onPrintLabel);
//-------------------------------------------------------------------------------

    this->addButtons(path, nom);
	this->setVectorFunction(funct);

	this->setButtonName(0, 'C');
	this->setButtonName(1, 'P');
	this->setButtonName(2, '-');
	this->setButtonName(3, '-');

	this->connectEvents(evtHandler);

}
void interfEditMenu::onCopy(wxCommandEvent& event){
	interfMainPanel::getInstance()->onCopy();
}
void interfEditMenu::onPaste(wxCommandEvent& event){

	interfMainPanel::getInstance()->onPaste();
}
void interfEditMenu::onUndo(wxCommandEvent& event){
	interfMainPanel::getInstance()->onUndo();
}
void interfEditMenu::onRedo(wxCommandEvent& event){
	interfMainPanel::getInstance()->onRedo();
}
void interfEditMenu::onPrintLabel(wxCommandEvent& event){
	interfMainPanel::getInstance()->onPrintLabel();
}

interfEditMenu::~interfEditMenu()
{
}

