#ifndef __interfSegmentationPanelsH__
#define __interfSegmentationPanelsH__

#include <wx/wx.h>
#include "mBarRange.h"


class interfSegmentationPanelVTK 
	: public wxPanel
{
public:
	interfSegmentationPanelVTK(wxWindow * parent);		
	~interfSegmentationPanelVTK();

	/**
	**	Responds to the events of the buttons, when the same panel is responsible for it. It gets the name
	**	of the button corresponding to the method that has to be executed,
	**	it uses attribute eventHandler to call the methods define by the application.
	**	see setEventHandler(wxEventHandler*)
	**/
	
	void  onSegmentationPressed(wxCommandEvent& event);

	void  onSegmentationPressedITK(wxCommandEvent& event);

	void setLabel(wxString tmpString);

private:

	//wxContourEventHandler* contourevent;
	wxPanel* configPanel;
	wxWindow* infoWin;
	wxPanel* segmentPanel;
	wxPanel* spreadPanel;
	wxPanel* segmentPanelITK;
	bool axisshown;

	void hideAxis();

	wxPanel* getSegmentationPanel(wxWindow* parent);

	void onSegmentationOneSlice( wxCommandEvent& event );

	void onSegmentationAllSlice( wxCommandEvent& event );

	wxSlider* _isovalue;

	mBarRange* _mbarrange;
	
	wxSlider* _sampling;

	wxStaticText* _staticTextSegmentation;

	wxRadioBox* methodRadiobox;
};

class interfSegmentationPanelITK
	: public wxPanel
{
public:
	interfSegmentationPanelITK(wxWindow * parent);		
	~interfSegmentationPanelITK();


	void onSegmentationOneSlice( wxCommandEvent& event );

	void onSegmentationAllSlice( wxCommandEvent& event );
	
private:

	wxTextCtrl * _distance;
	wxTextCtrl * _sigma;
	wxTextCtrl * _alfa;
	wxTextCtrl * _beta;
	wxTextCtrl * _propagation;
	wxTextCtrl * _iterations;
	wxTextCtrl * _infStrength;
};


class interfMirrorPanel
	: public wxPanel
{
public:
	interfMirrorPanel(wxWindow * parent);		
	~interfMirrorPanel();

private:

	wxSlider* _thickness;

	bool _axisStatus;

	void onAxisShow(wxCommandEvent& event);

	void onMirrorGo(wxCommandEvent& event);

	void onChangeWidth(wxScrollEvent& event);

	DECLARE_EVENT_TABLE()
};


#endif
 
 
