#ifndef __CONTOUR_THING__
#define __CONTOUR_THING__



//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include <iostream>
#include "CommandObject.h"
#include "ExecutableCommand.h"
#include "ComposedCommand.h"
#include "manualContourModel.h"

class ContourThing{

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------
public:

	/*
	* Creates a ContourThing 
	*/
	ContourThing(manualBaseModel * model);

	/*
	* Destroys a ContourThing 
	*/
	~ContourThing();
//------------------------------------------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------------------------------------------

	/*
	* 
	*/
	std::string getName();

	/*
	*
	*/
	void setName(std::string  aName);

	
	manualBaseModel * getModel();

	void setModel(manualBaseModel * model);

	/*
	* Executes the given command if posible and returns is posible or not
	* @param theSpecificCommand Is the specific command to execute
	* @return Returns if the command was successfuly executed
	*/
	bool executeCommand (CommandObject * theSpecificCommand);

	/*
	* Interprets the given command and constructs the opposite command for returning it
	* @param theSpecificDOCommand Is the specific DO command 
	* @return Returns the UNDO command of the given one
	*/
	CommandObject * getUndoCommandOf(CommandObject * theSpecificDOCommand);


//------------------------------------------------------------------------------------------------------------
// Constants
//------------------------------------------------------------------------------------------------------------

private: 	
//------------------------------------------------------------------------------------------------------------
// Attributes
//------------------------------------------------------------------------------------------------------------

	std::string outlineName;

	manualBaseModel * theModel;
};
#endif
