#ifndef __ICOMMANDS_USER__
#define __ICOMMANDS_USER__


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------

#include <iostream>
#include <deque>
#include "CommandObject.h"

class ICommandsUser{

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------
public:
   virtual ~ICommandsUser() {};

	
//------------------------------------------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------------------------------------------

	
	/*
	* Executes a command by resending the received parameters to its parent to do the appropiate interpretation and execution.
	* @param theCommand Is the command to execute
	* @param fromRegistration Indicates if the execution is directed from the registration, by default comes from the GUI = false.
	*/
	virtual bool executeCommand(CommandObject * theCommand, bool fromRegistration=false) = 0;
	
	/*
	* Executes a command queue by resending the received parameters to its parent to do the appropiate interpretation and execution.
	* @param executionQueue Is the command queue to execute
	* @param fromRegistration Indicates if the execution is directed from the registration, by default comes from the GUI = false.
	*/
	virtual bool executeCommandsQueue(std::deque<CommandObject *> & executionQueue, bool fromRegistration) = 0;

	
};
#endif

