#ifndef __INSTANT_MEMBERS_NAME_LIST__
#define __INSTANT_MEMBERS_NAME_LIST__


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include <vector>
#include <iostream>
#include <string>

#include "NameWrapper.h"


class InstantMembersNameList{

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------
public:

	/*
	* Create the InstantMembersNameList with empty data pointers
	*/
	InstantMembersNameList();

	/*
	* Destroys the InstantMembersNameList
	*/
	~InstantMembersNameList();

//------------------------------------------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------------------------------------------

	/*
	* Sets the actual outline names pair
	* @param thekeyName The key name asigned to the actual outline	
	* @param theRealName The real name asigned to the actual outline
	*/
	void setActualOutline(std::string thekeyName, std::string theRealName );

	/*
	* Sets the actual axes names pair
	* @param thekeyName The key name asigned to the actual outline	
	* @param theRealName The real name asigned to the actual outline
	*/
	void addOutlineName(std::string thekeyName, std::string theRealName);
	
	/*
	* Sets the actual axes names pair
	* @param thekeyName The key name asigned to the actual axe	
	* @param theRealName The real name asigned to the actual axe
	*/
	void setActualAxeWrap(std::string thekeyName, std::string theRealName);

	/*
	* Gets the actual axes key name
	* @return actualAxeKeyName The key name asigned to the actual axe
	*/
	std::string getActualAxeKeyName();

	/*
	* Gets the actual axes key name
	* @return actualSourceImageKeyName The key name asigned to the actual axe
	*/
	std::string getActualSourceImageKeyName();

	/*
	* Gets the actual axes key name
	* @return actualSectionImageKeyName The key name asigned to the actual axe
	*/
	std::string getActualSectionImageKeyName();

	/*
	* Gets the vector of the key names of currect instant outlines
	* @return vectorPairedNames The vector with the pair of outline names wrapping
	*/
	std::vector<NameWrapper *> getOutlinesNamesVector();


	/*
	* Sets the actualSourceImage names pair
	* @param thekeyName The key name asigned to the actual outline	
	* @param theRealName The real name asigned to the actual outline
	*/
	void setActualSourceImageNamesWrapp(std::string thekeyName, std::string theRealName);

	/*
	* Sets the actualSectionImage names pair
	* @param thekeyName The key name asigned to the actual outline	
	* @param theRealName The real name asigned to the actual outline
	*/
	void setActualSectionImageNamesWrapp(std::string thekeyName, std::string theRealName);
	
	/*
	* Cleans the vector and the information of the instant members wrapping
	*/
	void clean();

//------------------------------------------------------------------------------------------------------------
// Constants
//------------------------------------------------------------------------------------------------------------

private: 	
//------------------------------------------------------------------------------------------------------------
// Attributes
//------------------------------------------------------------------------------------------------------------

	std::vector<NameWrapper *> outlinesNamesVector;

	std::vector<std::string> axesNamesVector;

	NameWrapper * actualAxeNamesWrapp;

	NameWrapper * actualSourceImageNamesWrapp;

	NameWrapper * actualSectionImageNamesWrapp;

	NameWrapper * actualOutlineNamesWrapp;
};
#endif
