#ifndef __NAME_WRAPPER__
#define __NAME_WRAPPER__



//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include <iostream>

class NameWrapper{

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------
public:

	/*
	* Creates the NameWrapper
	* @param thekeyName The key name
	* @param theRealName  The real name
	* @return Returns the created NameWrapper 
	*/
	NameWrapper(std::string thekeyName, std::string theRealName);

	/*
	* Destroys the NameWrapper
	*/
	~NameWrapper();
//------------------------------------------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------------------------------------------

	/*
	* Sets the names pair to wrapp
	* @param thekeyName The key name
	* @param theRealName  The real name
	*/
	void setWrappingPair(std::string thekeyName, std::string theRealName );

	/*
	* Gets the wrapped key name
	* @param keyName The key name
	*/
	std::string getKeyName();

	/*
	* Gets the wrapped real name
	* @param realName The real name
	*/
	std::string getRealName();	

//------------------------------------------------------------------------------------------------------------
// Constants
//------------------------------------------------------------------------------------------------------------

private: 	
//------------------------------------------------------------------------------------------------------------
// Attributes
//------------------------------------------------------------------------------------------------------------

	/*
	* The wrapped key name
	*/
	std::string keyName;

	/*
	* The wrapped real name
	*/
	std::string realName;
	
};
#endif
